c_code {
	#define PI 3.141592653/*5897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679*/
	#define DEG 0.01745329
	#define ROBORAD 20
	#define OBRAD 10
	#define AAL 11
	#define AAR 69
	#define ADIST 8
	#define SENLEN 80
	#define LAMBDA 1
	#define OMEGAP 15
	#define ROBOMOVE 1
	#define ENVIDIAM 400
        #define ENVIRAD ENVIDIAM/2
	#define ANTLEN 6

	#define CRASHANGFROMCENTRE 9.825648155

//GLOBALS//


	double x = 0;
	double prevX = 0;

	double roboA = 0;
	long double enviA = 0;
	long double enviD = 0;

	double obD = 0;
	double obA = 0;
	double relD = 0;
	double relA = 0;

	int moveDist = 1;
	int obDist = 0;
	int obAng = 0;
	int inCone = 0;
	int debug = 0;

	int testFlag = 0;


//	fprintf(fp, "FINAL: curAng: %d. curDist: %d \n", obAng, obDist);

//	fclose(fp);

///////////
};


#define MOVE_FORWARD() { \
/*Declare Locals*/ \
if (now.relDist > 30) { \
	long double oZ = 0; \
	long double nZ = 0; \
	long double fZ = 0; \
	long double lOrg = 0; \
	long double hOrg = 0; \
	long double lNew = 0; \
	long double hNew = 0; \
	long double lFin = 0; \
	long double hFin = 0; \
	int oFR = 0; \
	int oFU = 0; \
	int nFR = 0; \
	int nFU = 0; \
\
if (debug ==2){ Printf("CCODEENVIS: enviD %Lf,    enviA %Lf. \n", enviD, enviA);} \
/*if (debug ==2) { fprintf(fpolar, "%Lf %Lf\n", enviA, enviD);}*/ \
	oZ = fmodl(enviA, (long double)90); \
	if ((enviA == 90) || (enviA ==270)) {lOrg = enviD; hOrg = 0; } \
	else if ((enviA == 0) || (enviA == 180)) {lOrg = 0; hOrg = enviD; } \
	else { \
		if ((enviA <=90) || ((enviA >=180)&&(enviA<=270))) { \
			lOrg = (sin(oZ*DEG))*enviD; \
			hOrg = (cos(oZ*DEG))*enviD; \
		} else { \
			hOrg = (sin(oZ*DEG))*enviD; \
			lOrg = (cos(oZ*DEG))*enviD; \
		} \
	} \
if (debug ==1){ Printf("ORIGINAL: hOrg %Lf,    lOrg %Lf,    oZ %Lf,    roboA %f. \n", hOrg, lOrg, oZ, roboA);} \
	nZ = fmod(roboA, 90.00);  \
	if ((roboA == 90) || (roboA ==270)) {lNew = moveDist; hNew = 0; } \
	else if ((roboA == 0) || (roboA == 180)) {lNew = 0; hNew = moveDist; } \
	else { \
		if ((roboA<90) || ((roboA>180)&&(roboA<270))) { \
			lNew = (sin(nZ*DEG))*moveDist; \
			hNew = (cos(nZ*DEG))*moveDist; \
		} else { \
			hNew = (sin(nZ*DEG))*moveDist; \
			lNew = (cos(nZ*DEG))*moveDist; \
		} \
	} \
if (debug ==1){ Printf("NEW:      hNew %Lf,    lNew %Lf,    nZ %Lf. \n", hNew, lNew, nZ);} \
	if ((enviA<180)&&(roboA>180) || (enviA>180)&&(roboA<180)) { lFin = fabs(lOrg - lNew);} \
 	else { 	lFin = lOrg + lNew;} \
	if ( (((enviA<90)||(enviA>270))&&((roboA>90)&&(roboA<270))) || (((enviA>90)&&(enviA<270))&&((roboA<90)||(roboA>270))) ) {  \
		hFin = fabs(hOrg - hNew); \
	} else { hFin = hOrg + hNew; } \
	if ((hFin!=0)&&(lFin!=0)) { fZ = (atan(hFin/lFin)*(180/PI)); } \
	else { fZ = 0;} \
	enviD = sqrt((lFin*lFin)+(hFin*hFin)); \
/*Finding the quadrant of the original position of the robot.*/ \
if (debug ==1){ Printf("FINAL:    hFin %Lf,    lFin %Lf,    fZ %Lf     enviD %Lf . \n", hFin, lFin, fZ, enviD);} \
	if ((enviA >=0) && (enviA <90))		 { oFR = 1; oFU = 1;} \
	else if ((enviA >= 90) && (enviA <180))	 { oFR = 1; oFU = 0;} \
	else if ((enviA >= 180) && (enviA <270)) { oFR = 0; oFU = 0;} \
	else if ((enviA >= 270) && (enviA <360)) { oFR = 0; oFU = 1;} \
	else {if (debug ==1){ Printf("FECKTAL ERROR with enviA = %Lf. \n", enviA);} oFR = 0; oFU = 0;} \
	nFR = oFR; \
	nFU = oFU; \
/*Finding the quadrant of the original position of the robot.*/ \
	if ((oFR==1) && (oFU==1)) {  \
		if ((roboA>=180) && (roboA<360) && (lNew > lOrg)) { nFR = 0;} \
		if ((roboA>=90) && (roboA<270) && (hNew > hOrg))  { nFU = 0;} \
	} \
	else if ((oFR==1) && (oFU==0)) {  \
		if ((roboA>=180) && (roboA<360) && (lNew > lOrg)) { nFR = 0;} \
		if ( (((roboA>=270)&&(roboA<360))||((roboA>=0)&&(roboA<90))) && (hNew > hOrg)) { nFU = 1;} \
	} \
	else if ((oFR==0) && (oFU==0)) {  \
		if ((roboA>=0) && (roboA<180) && (lNew > lOrg))   { nFR = 1;} \
		if ( (((roboA>=270)&&(roboA<360))||((roboA>=0)&&(roboA<90))) && (hNew > hOrg)) { nFU = 1;} \
	} \
	else if ((oFR==0) && (oFU==1)) {  \
		if ((roboA>=0) && (roboA<180) && (lNew > lOrg))   { nFR = 1;} \
		if ((roboA>=90) && (roboA<270) && (hNew > hOrg))  { nFU = 0;} \
	} \
if (debug ==1){ Printf("QUADRANT: (oFR %d, oFU %d),     (nFR %d, nFU %d),   fZ %Lf . \n", oFR, oFU, nFR, nFU, fZ);} \
/*Many catches for when the movement is along the axis lines/opposing them, or when both are the same.*/ \
	if (roboA==enviA) { enviA = roboA;} \
	else if ((roboA==180)&&(enviA==0)&&(hNew>hOrg)) {enviA = 180;} \
	else if ((roboA==180)&&(enviA==0)&&(hNew < hOrg)) {enviA = 0;} \
	else if ((roboA==180)&&(enviA==0)&&(hNew == hOrg)) {enviA = 0;} \
	else if ((roboA==0)&&(enviA==180)&&(hNew>hOrg)) {enviA = 0;} \
	else if ((roboA==0)&&(enviA==180)&&(hNew < hOrg)) {enviA = 180;} \
	else if ((roboA==0)&&(enviA==180)&&(hNew == hOrg)) {enviA = 0;} \
	else if ((roboA==90)&&(enviA==270)&&(lNew>lOrg)) {enviA = 90;} \
	else if ((roboA==90)&&(enviA==270)&&(lNew < lOrg)) {enviA = 270;} \
	else if ((roboA==90)&&(enviA==270)&&(lNew == lOrg)) {enviA = 0;} \
	else if ((roboA==270)&&(enviA==90)&&(lNew>lOrg)) {enviA = 270;} \
	else if ((roboA==270)&&(enviA==90)&&(lNew < lOrg)) {enviA = 90;} \
	else if ((roboA==270)&&(enviA==90)&&(lNew == lOrg)) {enviA = 0;} \
	else if ((nFR==1)&&(nFU==1)) { enviA = 90 - fZ;} \
	else if ((nFR==1)&&(nFU==0)) { enviA = 90 + fZ;} \
	else if ((nFR==0)&&(nFU==0)) { enviA = 270 - fZ;} \
	else if ((nFR==0)&&(nFU==1)) { enviA = 270 + fZ;} \
	if (enviA>=360) {now.enviAng = 0;} \
	else {now.enviAng = ((int)(2*enviA)) - ((int)enviA);} \
	enviD = ((int)(2*enviD)) - ((int)enviD); \
if (debug==1) {Printf("ENDofMOVE: now.enviDist: %d, now.enviAng %d, now.roboAng %d \n", now.enviDist, now.enviAng, now.roboAng);} \
/*Don't want to wrap from a wrap.*/ \
	if ((enviD>=ENVIRAD) && (now.doWrap==0)) { enviD = ENVIRAD; if (debug==2) {Printf("We wrap dawg? \n");} now.doWrap=1;} \
	now.enviDist = (int)enviD; \
if (debug==2) {Printf("MOVEBetter: now.enviDist: %d, now.enviAng %d, now.roboAng %d \n", now.enviDist, now.enviAng, now.roboAng);} \
} \
};


#define MOVE_ROBOT() c_code { \
if (debug==2) {Printf("In the move: now.roboAng %d, now.enviAng %d, now.enviDist %d, now.omegaD %d, obDist %d, obAng %d. \n", now.roboAng, now.enviAng, now.enviDist, now.omegaD, obDist, obAng);} \
\
/*Setting the roboA and the moveDist before MOVE_FORWARD() is called*/\
	roboA = (double) now.roboAng; \
	moveDist = ROBOMOVE; \
	MOVE_FORWARD(); \
};


#define GET_OB_REL_TO_ROBOT() {\
/*Declare Locals*/ \
	long double oZ = 0; \
	long double nZ = 0; \
	long double fZ = 0; \
	long double lOrg = 0; \
	long double hOrg = 0; \
	long double lNew = 0; \
	long double hNew = 0; \
	long double lFin = 0; \
	long double hFin = 0; \
	int furtherRight = 0; \
	int furtherUp = 0; \
	double roboED = 0; \
	double roboEA = 0; \
	double roboFarAntiClock = 0; \
	double relAN = 0; \
\
	roboA = (double) now.roboAng; \
	roboED = (double)enviD; /*(double) now.enviDist;*/ \
	roboEA = (double)enviA; /*(double) now.enviAng;*/ \
	obD = (double)obDist; \
	obA = (double)obAng; \
	oZ = ((int)roboEA)%90; \
	if ((roboEA == 90) || (roboEA ==270)) {lOrg = roboED; hOrg = 0; } \
	else if ((roboEA == 0) || (roboEA == 180)) {lOrg = 0; hOrg = roboED; } \
	else { \
		if ((roboEA <=90) || ((roboEA >=180)&&(roboEA<=270))) { \
			lOrg = (sin(oZ*DEG))*roboED; \
			hOrg = (cos(oZ*DEG))*roboED; \
		} else { \
			hOrg = (sin(oZ*DEG))*roboED; \
			lOrg = (cos(oZ*DEG))*roboED; \
		} \
	} \
	nZ = ((int)obA)%90; \
	if ((obA == 90) || (obA ==270)) {lNew = obD; hNew = 0; } \
	else if ((obA == 0) || (obA == 180)) {lNew = 0; hNew = obD; } \
	else { \
		if ((obA<90) || ((obA>180)&&(obA<270))) { \
			lNew = (sin(nZ*DEG))*obD; \
			hNew = (cos(nZ*DEG))*obD; \
		} else { \
			hNew = (sin(nZ*DEG))*obD; \
			lNew = (cos(nZ*DEG))*obD; \
		} \
	} \
	if ((roboEA<180)&&(obA>180) || (roboEA>180)&&(obA<180)) { lFin = lOrg + lNew;} \
 	else { 	lFin = fabs(lOrg - lNew);} \
	if ( (((roboEA<90)||(roboEA>270))&&((obA>90)&&(obA<270))) || (((roboEA>90)&&(roboEA<270))&&((obA<90)||(obA>270))) ) { \
		hFin = hOrg + hNew; \
	} else { hFin = fabs(hOrg - hNew);} \
	fZ = (atan(hFin/lFin)*(180/PI)); \
	if ((roboEA<=180)&&(obA<=180)) { if (lOrg > lNew) { furtherRight = 1;} else { furtherRight = 0;}} \
	else if ((roboEA>=180)&&(obA>=180)) { if (lOrg > lNew) { furtherRight = 0;} else { furtherRight = 1;}} \
	else if ((roboEA>180)&&(obA<180)) { furtherRight = 0;} \
	else if ((roboEA<180)&&(obA>180)) { furtherRight = 1;} \
	else {furtherRight = 0; furtherUp = 0;} \
	if (((roboEA<=90)||(roboEA>=270))&&((obA<=90)||(obA>=270))){ if(hOrg > hNew) { furtherUp=1;} else { furtherUp=0;}} \
	else if (((roboEA>=90)&&(roboEA<=270))&&((obA>=90)&&(obA<=270))) { if(hOrg>hNew) { furtherUp=0;} else { furtherUp=1;}} \
	else if (((roboEA<=90)||(roboEA>=270)) && ((obA>=90)&&(obA<=270))) { furtherUp = 1;} \
	else if (((roboEA>=90)&&(roboEA<=270)) && ((obA<=90)||(obA>=270))) { furtherUp = 0;} \
	if ((furtherRight==1) && (furtherUp==1)) { relAN = 270 - fZ;} \
	else if ((furtherRight==1) && (furtherUp==0)) { relAN = 270 + fZ;} \
	else if ((furtherRight==0) && (furtherUp==1)) { relAN = 90 + fZ;} \
	else if ((furtherRight==0) && (furtherUp==0)) { relAN = 90 - fZ;} \
	roboFarAntiClock = ((((int)roboA) - 40)+360)%360; \
	relAN = ((int)(2*relAN)) - ((int)relAN); \
	relA = (((int)(relAN - roboFarAntiClock))+360)%360; \
	relD = sqrt((hFin*hFin) + (lFin*lFin)); \
	if ((relA <= 80)&&(relD <= 90)) { inCone = 1; if (debug==2) {Printf("INCONE \n");}} \
	else { inCone = 0;} \
	now.relDist = ((int)(2*relD)) - ((int)relD); \
if (debug==2) {Printf("RELATIVE: now.relDist %d, relA = %f, relD = %f. \n", now.relDist, relA, relD);} \
	/*now.relAng = (int)relA;*/ \
};


#define RESPOND() c_code { \
	prevX = x; \
	now.prevSig = now.sig; \
	if (inCone==1) { \
		RESPOND_TO_OB_BY_TURNING(); \
		now.sig = (int)(fabs(x)); \
	} else { \
/*If not inCone then we need to reset the signals*/ \
		x = 0; \
		now.sig = 0; \
	} \
	Printf("SEND IN THE SIGNAL: now.sig %d, now.prevSig %d. \n", now.sig, now.prevSig); \
}; \


#define RESPOND_TO_OB_BY_TURNING() { \
/*Declare Locals*/ \
	double theta = 0; \
	double opp = 0; \
	double adj = 0; \
	double sAdj = 0; \
	double sHyp = 0; \
	int i = 0; \
	signed int flag = 0; \
	double contactPoint = 0; \
	double oAMAX = 0; \
	double lowR = 0; \
	double highR = 0; \
	double dOmegaD = 0; \
\
	roboA = (double)now.roboAng; \
	dOmegaD = (double)now.omegaD; \
	oAMAX = (atan((OBRAD/relD)))*(180/PI); \
	lowR = (relA - oAMAX); \
	if (lowR < 0) { lowR = 0;} \
	highR = (relA + oAMAX); \
	if (highR > 80) { highR = 80;} \
	if ( (AAL >= lowR) & (AAL <= highR) ) { theta = fabs(AAL - relA); flag = 1;} \
	else if ( (AAR >= lowR) & (AAR <= highR) ) { theta = fabs(AAR - relA); flag = -1;} \
	else {flag = 0;} \
	opp = relD*(sin(theta*(PI/180)));\
	if ((flag != 0 ) && (opp <= OBRAD)) { \
		adj = sqrt((relD*relD) - (opp*opp)); \
		if (adj <= 80) { \
			for (i=0; i<=10; i++) {		\
				sAdj = OBRAD - i; \
				sHyp = sqrt((sAdj*sAdj) + (opp*opp));	 \
				if ((sHyp != 0) & (sHyp <= OBRAD)) { 	\
					contactPoint = adj - sAdj;		\
					x = (flag)*(ADIST - ( ( contactPoint-(((int)contactPoint)%10) )/10 )); \
					x = ((int)(2*x)) - ((int)x); \
					break; \
				} \
			} \
		} \
		else { x = 0;} \
	} \
	else { x = 0;} 	\
	if ((x == 0) && (now.relDist <= 30)) { /*This is a crash*/ CRASH();} \
	else if (fabs(x) > 5) { roboA = (((int)(roboA + (x*OMEGAP)))+360)%360; LEARN_NOW();} \
	else { roboA = (((int)(roboA + (x*dOmegaD)))+360)%360;} \
	if (roboA>=360) { roboA=0;} \
	now.roboAng = (int)roboA; \
};


#define LEARN_NOW() { \
	if ( (prevX>=(-5)) && (prevX<=5) && (prevX!=0) ) { \
		now.omegaD = now.omegaD + LAMBDA;\
	} \
};


#define CRASH() { \
/*Declare Locals*/ \
	double oZ = 0; \
	double oOpp = 0; \
	double oAdj = 0; \
	double oHyp = 0; \
	double nZ = 0; \
	double nOpp = 0; \
	double nAdj = 0; \
\
	/*If we crash with no proximal impact --We are inCone*/ \
	if ((relA==40) && (relD==30)) { \
		now.headOn = 1; /*Promela macro? Fixed Angle is 9.825648155*/ \
	} else if ((relA>=30)&&(relA<40)) { \
		oZ = relA - 11; \
		oHyp = 30; \
		oOpp = sin(oZ*DEG)*oHyp; \
		oAdj = sqrt((oHyp*oHyp)-(oOpp*oOpp)); \
		nOpp = oOpp - OBRAD; \
		nAdj = oAdj; \
		nZ = (atan(nOpp/nAdj))*(180/PI); \
		x = 6; \
		roboA = ((int)(roboA + (x*OMEGAP) + nZ))%360; \
	} else if ((relA<=50)&&(relA>40)) { \
		oZ = (relA - 40) - 11; \
		oHyp = 30; \
		oOpp = sin(oZ*DEG)*oHyp; \
		oAdj = sqrt((oHyp*oHyp)-(oOpp*oOpp)); \
		nOpp = oOpp - OBRAD; \
		nAdj = oAdj; \
		nZ = (atan(nOpp/nAdj))*(180/PI); \
		x = (-6); \
		roboA = (((int)(roboA + (x*OMEGAP) - nZ))+360)%360; \
	} \
	/*We could round this angle nZ before we modulus it TODO: NOT SURE THIS SHOULD ALWAYS UPDATE WHEN ALSO UPDATED IN "HEAD_ON()".*/ \
	now.roboAng = ((int)(2*roboA)) - ((int)roboA); \
Printf("CRASH():nZ %f, roboA %f, now.roboAng %d. \n", nZ, roboA, now.roboAng); \
};


#define WRAP() c_code { \
/*Declare Locals*/ \
	int l = 0; \
	long double orgEnviA = 0; \
	long double orgEnviD = 0; \
	int oppAng = 0; \
\
	roboA = (double)now.roboAng; /*We don't want to change roboAng.*/ \
	moveDist = ENVIDIAM; \
	oppAng = ((int)(roboA+180))%360; \
	roboA = oppAng; /*for MF function.*/ \
	orgEnviA = enviA; \
	orgEnviD = enviD; \
\
if (debug==2) {	Printf("oppAng %d. \n", oppAng);} \
	MOVE_FORWARD(); \
	for (l=399; l--; l>=0) { \
	\
		if (enviD > ENVIRAD) { \
		/*Reset the envi Values.*/ \
			enviA = orgEnviA; \
			enviD = orgEnviD; \
			moveDist = l; \
			MOVE_FORWARD(); \
		} else {break;} \
	} \
	roboA = (double)now.roboAng; /*Reset the roboAng.*/ \
	now.doWrap = 0; \
};


#define TRIVIAL_WRAP() c_code { \
/*Printf("DOES THIS WORK!? \n");*/ \
if (debug==2) {Printf("DO WE WRAP: now.enviAng: %d, now.enviDist: %d \n", now.enviAng, now.enviDist);} \
		now.enviAng = (now.enviAng + 180)%360; \
		now.enviDist = ENVIRAD; \
		enviA = ((int)(2*enviA)) - ((int)enviA); \
		enviA = ((int)enviA + 180)%360; \
		enviD = ENVIRAD; \
if (debug==2) {Printf("DO WE WRAP, THINGS HAVE CHANGED: now.enviAng: %d, now.enviDist: %d \n", now.enviAng, now.enviDist);} \
		now.doWrap = 0; \
};

#define SCAN_APPROACHING_OBS() c_code { \
/*Declare Locals*/ \
	int j = 0; \
\
	inCone = 0; \
	for (j=0; j<OBMAX; j++) { \
		obDist = now.arrObs[j].d; \
		obAng = now.arrObs[j].a; \
if (debug==2) {Printf("THISOB: obDist: %d, obAng: %d \n", obDist, obAng);} \
		GET_OB_REL_TO_ROBOT(); \
		if (inCone==1) {break;} \
	} \
};
